## fastjet-3.5.1-1.src.tar.gz

=== CMakeLists.txt ===
# List of useful CMake arguments:
#  CMAKE_INSTALL_PREFIX=...     path for the installation
#                               (can be replaced be cmake --install . -- prefix <patth>)
#  FASTJET_ENABLE_DEBUG=ON|OFF  switch debugging info on/off [default:ON]
#  FASTJET_ENABLE_CGAL=ON|OFF   enable CGAL support [default:OFF]
#  FASTJET_ENABLE_PLUGIN_<name>=ON|OFF
#      with <name> in ATLASCONE, CDFCONES, CMSITERATIVECONE, D0RUNICONE, D0RUNIICONE,
#      EECAMBRIDGE, GRIDJET, JADE, NESTEDDEFS, PXCONE, SISCONE, TRACKJET; enable the
#      corresponding FastJet plugin [default:ON except for PxCone]
#
# Note on config file:
#  . include/fastjet/config_auto.h is generated from config-cmake.hh.in
#
# TODO:
# - [ ] incorporate build from cmake-installed version also into CI
# - [ ] have the option of building the testsuite
# - [ ] web page cmake documentation (e.g. quick-start) -> not for 3.5.0, wait until it's been used for a while
# - [x] fastjet-config script
#   - [x] support for --list-plugins
#   - [x] correct list of libraries when --plugins requested
#   - [x] --pythonpath
#   - [x] it is correctly installed
#   - [x] --config option?
# - [x] we are manually setting various compile flags, e.g. -g, -O2, etc.
#       which is not compatible with standard CMake build types
# - [x] checks
#   - [x] that siscone submodule is there 
#   - [x] that siscone/config.h does not exist in the source directory
# - [x] add PxCone support
# - [x] Check the "Release" build
# - [x] add missing examples -> simply moved them into examples/graveyard/
# - [x] make sure all CMakeLists.txt, config-cmake.hh.in, Config.cmake.in files included in tarball
# - [x] add Python support
# - [x] make sure we use shared libs# 
# - [x] specific compilation flags for the D0RunIICone
# - [x] print config summary
# - [x] scripts/set-version.sh should set the version info also in this file
# - [x] ctest to reproduce what make check does
#   - [x] and add it to CI
# - [x] check autotools tarball for cmake in CI
# - [x] CI also for cmake
#   - [x] basic functionality
#   - [x] address comments from M Feickert in !10 on test-all-algs and on python library path
#   - [x] check build from installed system, including fastjet-config and cmake routes
#         (see internal )
# - [x] Add instructions for CMake usage to documentation
#   - [x] for build & installation, and compilation as a text file
#   - [x] similarly in fastjet-doc.tex 
# - [x] make some decisions
#   - [x] what plugins turned on by default -> aim for same list as in autotools + enable-all, enable-allcxx
#   - [x] will we deprecate auto-tools? Schedule for removal when? -> not for 3.5.0
#   - [x] are we happy with Python arrangement (needing swig) -> Yes
# - [x] make sure out-of-source autotools build is (still?) working

cmake_minimum_required(VERSION 3.10.0..4.0.1)
include(CMakePrintHelpers)

# set the project name
project(FastJet VERSION 3.5.1 LANGUAGES CXX)
# set a pre-release version if relevant, e.g. "-beta1"
set(PROJECT_VERSION_PRERELEASE "")
include(GNUInstallDirs)

#----------------------------------------------------------------------
# version information
set(FASTJET_VERSION "${PROJECT_VERSION}${PROJECT_VERSION_PRERELEASE}")

set(FASTJET_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set(FASTJET_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(FASTJET_VERSION_PATCHLEVEL "${PROJECT_VERSION_PATCH}")
set(FASTJET_VERSION_PRERELEASE "${PROJECT_VERSION_PRERELEASE}")
# build a unique version number
if (FASTJET_VERSION_MINOR LESS 10)
  set(FASTJET_VERSION_MINOR_FOR_NUMBER "0${FASTJET_VERSION_MINOR}")
else()
  set(FASTJET_VERSION_MINOR_FOR_NUMBER "${FASTJET_VERSION_MINOR}")
endif()
if (FASTJET_VERSION_PATCHLEVEL LESS 10)
  set(FASTJET_VERSION_PATCHLEVEL_FOR_NUMBER "0${FASTJET_VERSION_PATCHLEVEL}")
else()
  set(FASTJET_VERSION_PATCHLEVEL_FOR_NUMBER "${FASTJET_VERSION_PATCHLEVEL}")
endif()
set(FASTJET_VERSION_NUMBER "${FASTJET_VERSION_MAJOR}${FASTJET_VERSION_MINOR_FOR_NUMBER}${FASTJET_VERSION_PATCHLEVEL_FOR_NUMBER}")

# print out the project name and version
cmake_print_variables(PROJECT_NAME FASTJET_VERSION)

# need this to be able to set the installation prefix in fastjet-config
include(GNUInstallDirs)

#----------------------------------------------------------------------
# basic C++ checks
#----------------------------------------------------------------------

# specify the C++ standard
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)  # <--- GPS 2025-05-22: disable GNU extensions, which cause problems with CGAL on amd64
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})
if (MSVC)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()
message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")



# Bail out if config_auto.h exists in the source directory
set (AUTOTOOLS_ERROR_MESSAGE "Found ${PROJECT_SOURCE_DIR}/include/fastjet/config_auto.h in source directory. This would typically have been generated by the autotools (non-CMake) build process. Please run cmake from a clean source directory.")
if (EXISTS "${PROJECT_SOURCE_DIR}/include/fastjet/config_auto.h")
  message(FATAL_ERROR "${AUTOTOOLS_ERROR_MESSAGE}")
endif()

#-------------------------------------------------------------------------
# a series of user-defined options
# If you add something here, check if one also needs to add a corresponding 
# entry in config-cmake.hh.in
#
# CGAL support
option(FASTJET_ENABLE_CGAL  
       "Enable compilation with CGAL (header-only) support, required for most of the NlnN strategies"  
       OFF)

# do we build the examples?
option(FASTJET_BUILD_EXAMPLES "Build the executables in the examples directory [default=ON]" ON)

# thread safety
option(FASTJET_HAVE_THREAD_SAFETY         "Turn on thread safety [default=ON]" ON)
option(FASTJET_HAVE_LIMITED_THREAD_SAFETY "Turn on limited thread safety [default=ON]" ON)
if (FASTJET_HAVE_THREAD_SAFETY)
  set(FASTJET_HAVE_LIMITED_THREAD_SAFETY ON)
endif()


# plugins on/off
option(FASTJET_ENABLE_PLUGIN_CDFCONES         "Enable the CDFCones plugin [default=ON]"           ON)
option(FASTJET_ENABLE_PLUGIN_EECAMBRIDGE      "Enable the EECambridge plugin [default=ON]"        ON)
option(FASTJET_ENABLE_PLUGIN_GRIDJET          "Enable the GridJet plugin [default=ON]"            ON)
option(FASTJET_ENABLE_PLUGIN_JADE             "Enable the Jade plugin [default=ON]"               ON)
option(FASTJET_ENABLE_PLUGIN_NESTEDDEFS       "Enable the NestedDefs plugin [default=ON]"         ON)
option(FASTJET_ENABLE_PLUGIN_SISCONE          "Enable the SISCone plugin [default=ON]"            ON)
option(FASTJET_USE_INSTALLED_SISCONE          "Use an existing installed version of siscone"     OFF)
option(FASTJET_ENABLE_PLUGIN_ATLASCONE        "Enable the ATLASCone plugin [default=OFF]"        OFF)
option(FASTJET_ENABLE_PLUGIN_CMSITERATIVECONE "Enable the CMSIterativeCone plugin [default=OFF]" OFF)
option(FASTJET_ENABLE_PLUGIN_D0RUNICONE       "Enable the D0RunICone plugin [default=OFF]"       OFF)
option(FASTJET_ENABLE_PLUGIN_D0RUNIICONE      "Enable the D0RunIICone plugin [default=OFF]"      OFF)
option(FASTJET_ENABLE_PLUGIN_PXCONE           "Enable the PxCone plugin [default=OFF]"           OFF)
option(FASTJET_ENABLE_PLUGIN_TRACKJET         "Enable the TrackJet plugin [default=OFF]"         OFF)

option(FASTJET_ENABLE_ALLCXXPLUGINS           "Enable all the C++ plugins [default=OFF]"       OFF)
option(FASTJET_ENABLE_ALLPLUGINS              "Enable all the plugins [default=OFF]"           OFF)

if (FASTJET_ENABLE_ALLCXXPLUGINS OR FASTJET_ENABLE_ALLPLUGINS)
  set(FASTJET_ENABLE_PLUGIN_ATLASCONE          ON)
  set(FASTJET_ENABLE_PLUGIN_CDFCONES           ON)
  set(FASTJET_ENABLE_PLUGIN_CMSITERATIVECONE   ON)
  set(FASTJET_ENABLE_PLUGIN_D0RUNICONE         ON)
  set(FASTJET_ENABLE_PLUGIN_D0RUNIICONE        ON)
  set(FASTJET_ENABLE_PLUGIN_EECAMBRIDGE        ON)
  set(FASTJET_ENABLE_PLUGIN_GRIDJET            ON)
  set(FASTJET_ENABLE_PLUGIN_JADE               ON)
  set(FASTJET_ENABLE_PLUGIN_NESTEDDEFS         ON)
  set(FASTJET_ENABLE_PLUGIN_SISCONE            ON)
  set(FASTJET_ENABLE_PLUGIN_TRACKJET           ON)
endif()

if (FASTJET_ENABLE_ALLPLUGINS)
  set(FASTJET_ENABLE_PLUGIN_PXCONE             ON)
endif()

# compile-time debugging info
option(FASTJET_ENABLE_DEBUG "Turn on debug compiler information [default=ON]" ON)

# disable auto-ptr by defaukt
option(FASTJET_HAVE_AUTO_PTR_INTERFACE  "Enable the (deprecated) auto_ptr interface [default=OFF]"  OFF)

# extra warnings
option(FASTJET_ENABLE_EXTRA_WARNINGS  "Enable compile=time extra warnings [default=OFF]"  OFF)

# support for "override" comes automatically as part of C++11 (can be manually disabled)
option(FASTJET_HAVE_OVERRIDE   "Compiler supports override"  ON)

# support for "[[deprecated]]" comes automatically as part of C++14 (can be manually disabled)
option(FASTJET_HAVE_CXX14_DEPRECATED   "Compiler supports [[deprecated]] (C++14)"  ON)

# support for "__attribute__(deprecated)" off by default (use [[deprecated instead]])
option(FASTJET_HAVE_GNUCXX_DEPRECATED "Compiler supports __attribute__(deprecated) (use [[deprecated]] instead"  OFF)

# support for "explicit operator" comes automatically as part of C++11 (can be manually disabled)
option(FASTJET_HAVE_EXPLICIT_FOR_OPERATORS  "Compiler supports explicit operator (C++11)"  ON)

# support for swig-based python bindings
option(FASTJET_ENABLE_PYTHON "Enable building of swig-based fastjet python bindings" OFF)
option(FASTJET_PYINTERFACE_ONLY "Only build the pyinterface model, relying on an external install of fastjet" OFF)

#-------------------------------------------------------------------------
# compile-time options
# add modules to help check compiler support
include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)

if (MSVC)
  message(WARNING "BUILDING FASTJET ON WINDOWS IS NOT SUPPORTED BY THE FASTJET AUTHORS!!!\nDO NOT EXPECT SUPPORT IF THINGS GO WRONG!!!\nWITHIN SCIKIT-BUILD-CORE, CONTACT SCIKIT DEVELOPERS FOR HELP")
  # This flags has been requested in some MRs. While it is included here
  # it has not been tested by the FastJet authors.
  add_compile_definitions(-D_USE_MATH_DEFINES)
endif()

# for every flag in FLAG_LIST, we will check if the compiler supports it
# and if so, add it to the list of compile options
set (FLAG_LIST "")
if (NOT MSVC)
  list(APPEND FLAG_LIST -Wall -Wshadow)
endif()


if (FASTJET_ENABLE_DEBUG)
  if (MSVC)
    list(APPEND FLAG_LIST /Zi)
  else()
    list(APPEND FLAG_LIST -g)
    list(APPEND FLAG_LIST -Woverloaded-virtual)
  endif()
endif()

if (FASTJET_ENABLE_EXTRA_WARNINGS)
  if (MSVC)
    list(APPEND FLAG_LIST /W4)
  else()
    list(APPEND FLAG_LIST -pedantic -Wextra -Wshadow)
  endif()
endif()

foreach(flag  ${FLAG_LIST})
  check_cxx_compiler_flag(${flag} FLAG_SUPPORTED)
  if (FLAG_SUPPORTED)
    message(STATUS "Checking if the compiler supports ${flag}: supported")
    # add_compile_options(...) would potentially apply to all languages, i.e. maybe 
    # also Fortran (PxCone) even though we have tested flags only for C++
    # so we use CMAKE_CXX_FLAGS here.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
    #add_compile_options(${flag})  
  else()
    message(STATUS "Checking if the compiler supports ${flag}: not supported")
  endif()
endforeach()

check_include_file_cxx(execinfo.h FASTJET_HAVE_EXECINFO_H)

if (FASTJET_HAVE_EXECINFO_H)
  try_compile(CXX_ABI_COMPILE_SUCCEEDED ${CMAKE_BINARY_DIR}/compiler-tests ${CMAKE_CURRENT_SOURCE_DIR}/compiler-tests/cxx_abi.cc)
  if (CXX_ABI_COMPILE_SUCCEEDED)
    message("-- C++ ABI support test passed; enabling demangling")
    option(FASTJET_HAVE_DEMANGLING_SUPPORT "Enabling C++ demangling (requires CXX ABI support)" ON)
  else()
    message("-- C++ ABI support test failed; disabling demangling")
    option(FASTJET_HAVE_DEMANGLING_SUPPORT "Enabling C++ demangling (requires CXX ABI support)" OFF)
  endif()
else()
  set(FASTJET_HAVE_DEMANGLING_SUPPORT  OFF)
endif()

=== example/CMakeLists.txt ===
#------------------------------------------------------------------------
# illustrative examples
#------------------------------------------------------------------------

# example 01-basic
add_executable(01-basic 01-basic.cc)
target_link_libraries(01-basic fastjet)

# example 02-jetdef
add_executable(02-jetdef 02-jetdef.cc)
target_link_libraries(02-jetdef fastjet)

# example 03-plugin
add_executable(03-plugin 03-plugin.cc)
target_link_libraries(03-plugin fastjet)
if (FASTJET_ENABLE_PLUGIN_SISCONE)
  target_include_directories(03-plugin PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../plugins/SISCone)
  target_link_libraries(03-plugin fastjetplugins siscone::siscone siscone::siscone_spherical)
endif()

# example 04-constituents
add_executable(04-constituents 04-constituents.cc)
target_link_libraries(04-constituents fastjet)

# example 05-eplus_eminus
add_executable(05-eplus_eminus 05-eplus_eminus.cc)
target_link_libraries(05-eplus_eminus fastjet)

# example 06-area
add_executable(06-area 06-area.cc)
target_link_libraries(06-area fastjet)

# example 07-subtraction
add_executable(07-subtraction 07-subtraction.cc)
target_link_libraries(07-subtraction fastjettools)

# example 08-selector
add_executable(08-selector 08-selector.cc)
target_link_libraries(08-selector fastjet)

# example 09-user_info
add_executable(09-user_info 09-user_info.cc)
target_link_libraries(09-user_info fastjet)

# example 10-subjets
add_executable(10-subjets 10-subjets.cc)
target_link_libraries(10-subjets fastjet)

# example 11-filter
add_executable(11-filter 11-filter.cc)
target_link_libraries(11-filter fastjettools)

# example 12-boosted_higgs
add_executable(12-boosted_higgs 12-boosted_higgs.cc)
target_link_libraries(12-boosted_higgs fastjettools)

# example 13-boosted_top
add_executable(13-boosted_top 13-boosted_top.cc)
target_link_libraries(13-boosted_top fastjettools)

# example 14-groomers
add_executable(14-groomers 14-groomers.cc)
target_link_libraries(14-groomers fastjettools)


#------------------------------------------------------------------------
# historic examples
#------------------------------------------------------------------------
add_executable(fastjet_example fastjet_example.cc)
target_link_libraries(fastjet_example fastjet)

add_executable(fastjet_areas fastjet_areas.cc)
target_link_libraries(fastjet_areas fastjet)
if (FASTJET_ENABLE_PLUGIN_SISCONE)
  target_link_libraries(fastjet_areas fastjetplugins siscone::siscone siscone::siscone_spherical)
endif()

# fastjet_timing_plugins
add_executable(fastjet_timing_plugins fastjet_timing_plugins.cc CmdLine.cc)
target_link_libraries(fastjet_timing_plugins PUBLIC fastjetplugins fastjettools)
if (FASTJET_ENABLE_PLUGIN_SISCONE)
  target_link_libraries(fastjet_timing_plugins PUBLIC siscone::siscone siscone::siscone_spherical)
endif()
# loop over all LIST_ALL_PLUGINS and make sure that the corresponding
# directories are added to the include list for fastjet_timing_plugins
foreach(plugin ${LIST_ALL_PLUGINS})
  target_include_directories(fastjet_timing_plugins PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../plugins/${plugin})
endforeach()

=== include/CMakeLists.txt ===
# just resurse into th eFastJet directory
add_subdirectory(fastjet)

=== plugins/CMakeLists.txt ===

# Beware: LIST_ALL_PLUGINS variable name is used also in fastjet-config
# and autotools, so changing it will cause trouble elsewhere

set(combined_objects)
if (FASTJET_ENABLE_PLUGIN_ATLASCONE)
   add_subdirectory(ATLASCone)
   list(APPEND combined_objects $<TARGET_OBJECTS:ATLASConePlugin>)
   list(APPEND LIST_ALL_PLUGINS "ATLASCone")
endif()
if (FASTJET_ENABLE_PLUGIN_CDFCONES)
   add_subdirectory(CDFCones)
   list(APPEND combined_objects $<TARGET_OBJECTS:CDFConesPlugin>)
   list(APPEND LIST_ALL_PLUGINS "CDFCones")
endif()
if (FASTJET_ENABLE_PLUGIN_CMSITERATIVECONE)
   add_subdirectory(CMSIterativeCone)
   list(APPEND combined_objects $<TARGET_OBJECTS:CMSIterativeConePlugin>)
   list(APPEND LIST_ALL_PLUGINS "CMSIterativeCone")
endif()
if (FASTJET_ENABLE_PLUGIN_D0RUNICONE)
   add_subdirectory(D0RunICone)
   list(APPEND combined_objects $<TARGET_OBJECTS:D0RunIConePlugin>)
   list(APPEND LIST_ALL_PLUGINS "D0RunICone")
endif()
if (FASTJET_ENABLE_PLUGIN_D0RUNIICONE)
   add_subdirectory(D0RunIICone)
   list(APPEND combined_objects $<TARGET_OBJECTS:D0RunIIConePlugin>)
   list(APPEND LIST_ALL_PLUGINS "D0RunIICone")
endif()
if (FASTJET_ENABLE_PLUGIN_EECAMBRIDGE)
   add_subdirectory(EECambridge)
   list(APPEND combined_objects $<TARGET_OBJECTS:EECambridgePlugin>)
   list(APPEND LIST_ALL_PLUGINS "EECambridge")
endif()
if (FASTJET_ENABLE_PLUGIN_GRIDJET)
   add_subdirectory(GridJet)
   list(APPEND combined_objects $<TARGET_OBJECTS:GridJetPlugin>)
   list(APPEND LIST_ALL_PLUGINS "GridJet")
endif()
if (FASTJET_ENABLE_PLUGIN_JADE)
   add_subdirectory(Jade)
   list(APPEND combined_objects $<TARGET_OBJECTS:JadePlugin>)
   list(APPEND LIST_ALL_PLUGINS "Jade")
endif()
if (FASTJET_ENABLE_PLUGIN_NESTEDDEFS)
   add_subdirectory(NestedDefs)
   list(APPEND combined_objects $<TARGET_OBJECTS:NestedDefsPlugin>)
   list(APPEND LIST_ALL_PLUGINS "NestedDefs")
endif()
if (FASTJET_ENABLE_PLUGIN_PXCONE)
   include(CheckLanguage)
   check_language(Fortran)
   enable_language(Fortran)
   add_compile_options($<$<COMPILE_LANGUAGE:Fortran>:-O3>)
   add_subdirectory(PxCone)
   list(APPEND combined_objects $<TARGET_OBJECTS:PxConePlugin>)
   list(APPEND LIST_ALL_PLUGINS "PxCone")
endif()
if (FASTJET_ENABLE_PLUGIN_SISCONE)
   add_subdirectory(SISCone)
   list(APPEND combined_objects $<TARGET_OBJECTS:SISConePlugin>)
   list(APPEND LIST_ALL_PLUGINS "SISCone")
endif()
if (FASTJET_ENABLE_PLUGIN_TRACKJET)
   add_subdirectory(TrackJet)
   list(APPEND combined_objects $<TARGET_OBJECTS:TrackJetPlugin>)
   list(APPEND LIST_ALL_PLUGINS "TrackJet")
endif()

# make sure the parent gets access to the list of plugins
set(LIST_ALL_PLUGINS "${LIST_ALL_PLUGINS}" PARENT_SCOPE)

# build a local library
add_library(fastjetplugins SHARED ${combined_objects})
target_link_libraries(fastjetplugins PUBLIC fastjet)

target_include_directories(fastjetplugins PUBLIC 
                             $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/Jade>
                             $<INSTALL_INTERFACE:include>
                           )

add_library(fastjet::fastjetplugins ALIAS fastjetplugins)

# NB this is specifically for building scikit-hep/fastjet wheels
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set_target_properties(fastjetplugins PROPERTIES INSTALL_RPATH "@loader_path")
else()
  set_target_properties(fastjetplugins PROPERTIES INSTALL_RPATH "$ORIGIN")
endif()

# make sure the SISCone libraries are included if necessary
if (FASTJET_ENABLE_PLUGIN_SISCONE)
   target_link_libraries(fastjetplugins PUBLIC siscone::siscone siscone::siscone_spherical)
endif()

# here we specify that runtime library components (e.g. .dlls, but not .so or .dylib)
# go into the binary directory (e.g. /bin, rather than the library directory e.g /lib)
# this is typical organization on windows installs
install(TARGETS
          fastjetplugins
        EXPORT
          FastjetTargets
        RUNTIME
          COMPONENT Runtime
          DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY
          COMPONENT Runtime
          DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE
          COMPONENT Development
          DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )

=== src/CMakeLists.txt ===

list(APPEND fastjet_SOURCES
  DnnPlane.cc
  Dnn4piCylinder.cc
  Dnn3piCylinder.cc
  Dnn2piCylinder.cc
  ClusterSequence.cc
  PseudoJet.cc
  Selector.cc
  ClusterSequence_N2.cc
  ClusterSequence_TiledN2.cc
  ClusterSequence_Delaunay.cc
  ClusterSequence_DumbN3.cc
  ClusterSequence_CP2DChan.cc
  ClosestPair2D.cc
  MinHeap.cc
  ClusterSequenceAreaBase.cc
  ClusterSequenceActiveAreaExplicitGhosts.cc
  ClusterSequenceArea.cc
  GhostedAreaSpec.cc
  ClusterSequenceActiveArea.cc
  Voronoi.cc
  ClusterSequenceVoronoiArea.cc
  ClusterSequencePassiveArea.cc
  ClusterSequence1GhostPassiveArea.cc
  PseudoJetStructureBase.cc
  ClusterSequenceStructure.cc
  BasicRandom.cc
  JetDefinition.cc
  Error.cc
  AreaDefinition.cc
  RangeDefinition.cc
  CompositeJetStructure.cc
  FunctionOfPseudoJet.cc
  LimitedWarning.cc
  TilingExtent.cc
  LazyTiling9.cc
  LazyTiling9Alt.cc
  LazyTiling25.cc
  LazyTiling9SeparateGhosts.cc
  RectangularGrid.cc
)

#-------------------------------------------------------------------------
# main code 
add_library(fastjet SHARED ${fastjet_SOURCES})
if (FASTJET_ENABLE_CGAL)
  target_link_libraries(fastjet PUBLIC CGAL::CGAL)
endif()
target_include_directories(fastjet 
                           PUBLIC
                            $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
                            $<INSTALL_INTERFACE:include>
                           )
target_include_directories(fastjet 
                           PUBLIC
                            $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
                            $<INSTALL_INTERFACE:include>
                           )

add_library(fastjet::fastjet ALIAS fastjet)

# here we specify that runtime library components (e.g. .dlls, but not .so or .dylib)
# go into the binary directory (e.g. /bin, rather than the library directory e.g /lib)
# this is typical organization on windows installs
install(TARGETS
          fastjet 
        EXPORT 
          FastjetTargets
        RUNTIME
          COMPONENT Runtime
          DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY
          COMPONENT Runtime
          DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE
          COMPONENT Development
          DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )

=== plugins/ATLASCone/CMakeLists.txt ===
# sources
list(APPEND ATLASConePlugin_SOURCES
  Jet.cc
  JetConeFinderTool.cc
  JetSplitMergeTool.cc
  ATLASConePlugin.cc
)

# headers that will eventually have to be installed?
# CommonUtils.hh JetConeFinderTool.hh JetDistances.hh Jet.hh JetSplitMergeTool.hh LorentzVector.hh
# LG - doesn't look like it since they're only needed for defining internal symbols,
#      not an interface.

# build a local library
add_library(ATLASConePlugin OBJECT ${ATLASConePlugin_SOURCES})
set_property(TARGET ATLASConePlugin PROPERTY POSITION_INDEPENDENT_CODE ON)

target_link_libraries(ATLASConePlugin PUBLIC fastjet)

# directly install the header from here
install(FILES fastjet/ATLASConePlugin.hh DESTINATION include/fastjet)

if (MSVC)
  target_compile_definitions(ATLASConePlugin PUBLIC -D_USE_MATH_DEFINES)
endif()

=== plugins/CDFCones/CMakeLists.txt ===
# sources
list(APPEND CDFConesPlugin_SOURCES
  CDFcode/CalTower.cc
  CDFcode/Centroid.cc
  CDFcode/Cluster.cc
  CDFcode/ClusterComparisons.cc
  CDFcode/JetCluAlgorithm.cc
  CDFcode/LorentzVector.cc
  CDFcode/MidPointAlgorithm.cc
  CDFcode/PhysicsTower.cc
  CDFJetCluPlugin.cc
  CDFMidPointPlugin.cc
)

# build a local library
add_library(CDFConesPlugin OBJECT ${CDFConesPlugin_SOURCES})
set_property(TARGET CDFConesPlugin PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(CDFConesPlugin PUBLIC CDFcode)
target_link_libraries(CDFConesPlugin PUBLIC fastjet)

# directly install the header from here
install(FILES fastjet/CDFJetCluPlugin.hh fastjet/CDFMidPointPlugin.hh DESTINATION include/fastjet)

=== plugins/CMSIterativeCone/CMakeLists.txt ===
# sources
list(APPEND CMSIterativeConePlugin_SOURCES
  CMSIterativeConePlugin.cc
)


# build a local library
add_library(CMSIterativeConePlugin OBJECT ${CMSIterativeConePlugin_SOURCES})
set_property(TARGET CMSIterativeConePlugin PROPERTY POSITION_INDEPENDENT_CODE ON)

target_link_libraries(CMSIterativeConePlugin PUBLIC fastjet)

# directly install the header from here
install(FILES fastjet/CMSIterativeConePlugin.hh DESTINATION include/fastjet)

if (MSVC)
  target_compile_definitions(CMSIterativeConePlugin PUBLIC -D_USE_MATH_DEFINES)
endif()

=== plugins/D0RunIICone/CMakeLists.txt ===
# sources
list(APPEND D0RunIIConePlugin_SOURCES
  D0RunIIConePlugin.cc
)

# build a local library
add_library(D0RunIIConePlugin OBJECT ${D0RunIIConePlugin_SOURCES})
set_property(TARGET D0RunIIConePlugin PROPERTY POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(D0RunIIConePlugin PRIVATE -Dfastjetplugins_EXPORTS)

if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  target_compile_options(D0RunIIConePlugin PUBLIC /Ob0)
else()
  check_cxx_compiler_flag(-fno-inline D0_CHECK_NO_INLINE)
  if (D0_CHECK_NO_INLINE)
    target_compile_options(D0RunIIConePlugin PUBLIC -fno-inline)
  else()
    check_cxx_compiler_flag(-O0 D0_CHECK_O0)
    if (D0_CHECK_O0)
      target_compile_options(D0RunIIConePlugin PUBLIC -O0)
    endif() 
  endif()
endif()

target_link_libraries(D0RunIIConePlugin PUBLIC fastjet)

# directly install the header from here
install(FILES fastjet/D0RunIIConePlugin.hh DESTINATION include/fastjet)

=== plugins/Jade/CMakeLists.txt ===
# sources
list(APPEND JadePlugin_SOURCES
  JadePlugin.cc
)

# build a local library
add_library(JadePlugin OBJECT ${JadePlugin_SOURCES})
set_property(TARGET JadePlugin PROPERTY POSITION_INDEPENDENT_CODE ON)

target_include_directories(JadePlugin PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(JadePlugin PUBLIC fastjet)

# directly install the header from here
install(FILES fastjet/JadePlugin.hh DESTINATION include/fastjet)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Frank Siegert <frank.siegert@googlemail.com>

pkgname=fastjet
pkgver=3.5.1
pkgrel=1
pkgdesc="A particle physics package for jet finding in pp and e+e- collisions."
arch=('x86_64')
url="http://fastjet.fr"
license=('GPL2')
depends=('bash')
makedepends=('gcc-fortran' 'python')
source=("http://fastjet.fr/repo/$pkgname-$pkgver.tar.gz")
sha512sums=('b5551eea8f9304e732c169227b0a8a005eb4c44534843e14e2270aef06aad56ba52fb42e5397120615b14f0edc34e825eb547b4e6ac578dcd9806d47e41fa3ca')

build() {
  cd $pkgname-$pkgver
  ./configure --prefix=/usr --enable-allplugins --enable-static=no --enable-pyext
  make
}

check() {
  cd $pkgname-$pkgver
  make -k check
}

package() {
  cd $pkgname-$pkgver
  make DESTDIR="$pkgdir/" install
}
